[wishlist] create a tool that process dep3 "Applied-Upstream" field

Bug #1787455 reported by Simon Déziel on 2018-08-16
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
usd-importer
Wishlist
Unassigned

Bug Description

DEP-3 has an optional field for "Applied-Upstream". This could be leveraged to drop some patches that were integrated by upstream without requiring manual intervention.

Robie Basak (racb) wrote :

Thank you for the suggestion.

git-ubuntu doesn't currently have visibility of upstream commits though. We could eventually get that through https://wiki.debian.org/UpstreamMetadata, but even then, we aren't currently adopting upstreamm commits into the git-ubuntu branch. So how should we detect if a patch has been integrated?

tags: added: merge workflow
Changed in usd-importer:
importance: Undecided → Wishlist
Nish Aravamudan (nacc) wrote :

I was thinking that, at a minimum, git-ubuntu (e.g., in lint) could check if the merge target is past the Applied-Upstream of any patch and if so, emit a warning?

On 2018-08-16 05:10 PM, Nish Aravamudan wrote:
> I was thinking that, at a minimum, git-ubuntu (e.g., in lint) could
> check if the merge target is past the Applied-Upstream of any patch and
> if so, emit a warning?

That's what I was thinking too.

Robie Basak (racb) wrote :

On Thu, Aug 16, 2018 at 09:10:13PM -0000, Nish Aravamudan wrote:
> I was thinking that, at a minimum, git-ubuntu (e.g., in lint) could
> check if the merge target is past the Applied-Upstream of any patch and
> if so, emit a warning?

What does "merge target is past the Applied-Upstream" mean, though?
The Applied-Upstream commit itself will never end up in the git-ubuntu
branch, AFAIK. What am I missing?

Simon Déziel (sdeziel) wrote :

Granted, if the Applied-Upstream is a URL/commit ID, git-ubuntu won't be able to do much about it unless it learns about the upstream remote as well. But, the Applied-Upstream field can also refer to an upstream version incorporating/superseeding the said patch. In such case, it would be a simple version string comparison.

Robie Basak (racb) wrote :

On Sun, Aug 19, 2018 at 09:53:04PM -0000, Simon Déziel wrote:
> But, the Applied-Upstream field can also refer to an upstream
> version incorporating/superseeding the said patch.

Ah. That's what I was missing. Thanks!

Though does still rely on the upstream version numbering scheme being
one that we can compare against the Debian packaging upstream version
for ordering?

Nish Aravamudan (nacc) wrote :

On Sun, Aug 19, 2018, 4:05 PM Robie Basak <email address hidden>
wrote:

> On Sun, Aug 19, 2018 at 09:53:04PM -0000, Simon Déziel wrote:
> > But, the Applied-Upstream field can also refer to an upstream
> > version incorporating/superseeding the said patch.
>
> Ah. That's what I was missing. Thanks!
>
> Though does still rely on the upstream version numbering scheme being
> one that we can compare against the Debian packaging upstream version
> for ordering?
>

Definitely, I assume we do:

Try and parse both applied and changelog version
If parse successfully, emit lint warning if it should be dropped
If parse failure, emit lint warning about misparse and inform us of found
upstream version and they should check if it still necessary.

I'm not exactly sure where in the flow this makes sense. If it's delta and
we are rebasing to new/debian, actual testing should show a failure (during
quilt push). So the lint message isn't useful probably? Maybe merge and
lint can check this somehow? `git ubuntu merge --lint` that calls the same
code `git ubuntu lint`. Future in any case :)

> --
> You received this bug notification because you are a member of Ubuntu
> Server Dev import team, which is subscribed to usd-importer.
> https://bugs.launchpad.net/bugs/1787455
>
> Title:
> [wishlist] create a tool that process dep3 "Applied-Upstream" field
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/usd-importer/+bug/1787455/+subscriptions
>
> Launchpad-Notification-Type: bug
> Launchpad-Bug: product=usd-importer; status=New; importance=Wishlist;
> assignee=None;
> Launchpad-Bug-Tags: merge workflow
> Launchpad-Bug-Information-Type: Public
> Launchpad-Bug-Private: no
> Launchpad-Bug-Security-Vulnerability: no
> Launchpad-Bug-Commenters: nacc racb sdeziel
> Launchpad-Bug-Reporter: Simon Déziel (sdeziel)
> Launchpad-Bug-Modifier: Robie Basak (racb)
> Launchpad-Message-Rationale: Subscriber (usd-importer) @usd-import-team
> Launchpad-Message-For: usd-import-team
>

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers